/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_ubyte_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return pattern29 (); /* [-1, 2] */
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          switch (pattern18 (x3, 
E_QImode))
            {
            case 0:
              return 23; /* *zero_extendqiqi2 */

            case 1:
              return 24; /* *zero_extendhiqi2 */

            case 2:
              return 25; /* *zero_extendsiqi2 */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern18 (x3, 
E_HImode))
            {
            case 0:
              return 26; /* *zero_extendqihi2 */

            case 1:
              return 27; /* *zero_extendhihi2 */

            case 2:
              return 28; /* *zero_extendsihi2 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern18 (x3, 
E_SImode))
            {
            case 0:
              return 29; /* *zero_extendqisi2 */

            case 1:
              return 30; /* *zero_extendhisi2 */

            case 2:
              return 31; /* *zero_extendsisi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern18 (x3, 
E_DImode))
            {
            case 0:
              return 32; /* zero_extendqidi2 */

            case 1:
              return 33; /* zero_extendhidi2 */

            case 2:
              return 34; /* zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 235; /* and_implqiqiqi__z_noz0_z1_z2 */

        case 1:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 288; /* and_implqihihi__z_noz0_z1_z2 */

        case 2:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 318; /* and_implqisisi__z_noz0_z1_z2 */

        case 3:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 328; /* and_implhiqiqi__z_noz0_z1_z2 */

        case 4:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 365; /* and_implhihihi__z_noz0_z1_z2 */

        case 5:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 413; /* and_implhisisi__z_noz0_z1_z2 */

        case 6:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 423; /* and_implsiqiqi__z_noz0_z1_z2 */

        case 7:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 453; /* and_implsihihi__z_noz0_z1_z2 */

        case 8:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 495; /* and_implsisisi__z_noz0_z1_z2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 240; /* ior_implqiqiqi__z_noz0_z1_z2 */

        case 1:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 290; /* ior_implqihihi__z_noz0_z1_z2 */

        case 2:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 320; /* ior_implqisisi__z_noz0_z1_z2 */

        case 3:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 330; /* ior_implhiqiqi__z_noz0_z1_z2 */

        case 4:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 370; /* ior_implhihihi__z_noz0_z1_z2 */

        case 5:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 415; /* ior_implhisisi__z_noz0_z1_z2 */

        case 6:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 425; /* ior_implsiqiqi__z_noz0_z1_z2 */

        case 7:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 455; /* ior_implsihihi__z_noz0_z1_z2 */

        case 8:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 500; /* ior_implsisisi__z_noz0_z1_z2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 245; /* xor_implqiqiqi__z_noz0_z1_z2 */

        case 1:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 292; /* xor_implqihihi__z_noz0_z1_z2 */

        case 2:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 322; /* xor_implqisisi__z_noz0_z1_z2 */

        case 3:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 332; /* xor_implhiqiqi__z_noz0_z1_z2 */

        case 4:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 375; /* xor_implhihihi__z_noz0_z1_z2 */

        case 5:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 417; /* xor_implhisisi__z_noz0_z1_z2 */

        case 6:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 427; /* xor_implsiqiqi__z_noz0_z1_z2 */

        case 7:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 457; /* xor_implsihihi__z_noz0_z1_z2 */

        case 8:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 505; /* xor_implsisisi__z_noz0_z1_z2 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 250; /* umin_implqiqiqi__z_noz0_z1_z2 */

        case 1:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 294; /* umin_implqihihi__z_noz0_z1_z2 */

        case 2:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 324; /* umin_implqisisi__z_noz0_z1_z2 */

        case 3:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 334; /* umin_implhiqiqi__z_noz0_z1_z2 */

        case 4:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 380; /* umin_implhihihi__z_noz0_z1_z2 */

        case 5:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 419; /* umin_implhisisi__z_noz0_z1_z2 */

        case 6:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 429; /* umin_implsiqiqi__z_noz0_z1_z2 */

        case 7:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 459; /* umin_implsihihi__z_noz0_z1_z2 */

        case 8:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 510; /* umin_implsisisi__z_noz0_z1_z2 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 255; /* umax_implqiqiqi__z_noz0_z1_z2 */

        case 1:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 296; /* umax_implqihihi__z_noz0_z1_z2 */

        case 2:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
            return -1;
          return 326; /* umax_implqisisi__z_noz0_z1_z2 */

        case 3:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 336; /* umax_implhiqiqi__z_noz0_z1_z2 */

        case 4:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 385; /* umax_implhihihi__z_noz0_z1_z2 */

        case 5:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
            return -1;
          return 421; /* umax_implhisisi__z_noz0_z1_z2 */

        case 6:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 431; /* umax_implsiqiqi__z_noz0_z1_z2 */

        case 7:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 461; /* umax_implsihihi__z_noz0_z1_z2 */

        case 8:
          if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
            return -1;
          return 515; /* umax_implsisisi__z_noz0_z1_z2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          switch (pattern19 (x3, 
E_QImode))
            {
            case 0:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (QImode)))
                return -1;
              return 568; /* lshr_implqiqiqi__z_noz0_z1_z2 */

            case 1:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (QImode)))
                return -1;
              return 577; /* lshr_implqihihi__z_noz0_z1_z2 */

            case 2:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (QImode)))
                return -1;
              return 583; /* lshr_implqisisi__z_noz0_z1_z2 */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern19 (x3, 
E_HImode))
            {
            case 0:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (HImode)))
                return -1;
              return 585; /* lshr_implhiqiqi__z_noz0_z1_z2 */

            case 1:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (HImode)))
                return -1;
              return 594; /* lshr_implhihihi__z_noz0_z1_z2 */

            case 2:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (HImode)))
                return -1;
              return 602; /* lshr_implhisisi__z_noz0_z1_z2 */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern19 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (QImode) < GET_MODE_SIZE (SImode)))
                return -1;
              return 604; /* lshr_implsiqiqi__z_noz0_z1_z2 */

            case 1:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (HImode) < GET_MODE_SIZE (SImode)))
                return -1;
              return 610; /* lshr_implsihihi__z_noz0_z1_z2 */

            case 2:
              if (!
#line 221 "../../gcc/config/pru/alu-zext.md"
(GET_MODE_SIZE (SImode) < GET_MODE_SIZE (SImode)))
                return -1;
              return 620; /* lshr_implsisisi__z_noz0_z1_z2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
