/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      return pattern8 (x3); /* [-1, 17] */

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern9 (x3, 
E_QImode) != 0)
                return -1;
              return 18;

            case E_HImode:
              if (pattern9 (x3, 
E_HImode) != 0)
                return -1;
              return 19;

            case E_SImode:
              if (pattern9 (x3, 
E_SImode) != 0)
                return -1;
              return 20;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 21; /* [21, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern29 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 2)
    return -1;
  switch (XINT (x2, 1))
    {
    case 0:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  switch (pattern30 (x2, 
E_QImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 142; /* pru_lmbd_implqiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 146; /* pru_lmbd_implqiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 148; /* pru_lmbd_implqiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 150; /* pru_lmbd_implqihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 151; /* pru_lmbd_implqihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 152; /* pru_lmbd_implqihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 153; /* pru_lmbd_implqisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 154; /* pru_lmbd_implqisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 155; /* pru_lmbd_implqisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                case E_HImode:
                  switch (pattern30 (x2, 
E_HImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 156; /* pru_lmbd_implhiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 157; /* pru_lmbd_implhiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 158; /* pru_lmbd_implhiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 159; /* pru_lmbd_implhihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 161; /* pru_lmbd_implhihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 165; /* pru_lmbd_implhihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 167; /* pru_lmbd_implhisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 168; /* pru_lmbd_implhisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 169; /* pru_lmbd_implhisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                case E_SImode:
                  switch (pattern30 (x2, 
E_SImode))
                    {
                    case 0:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 170; /* pru_lmbd_implsiqiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 171; /* pru_lmbd_implsiqihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 172; /* pru_lmbd_implsiqisi__z_z1_z2 */

                    case 1:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 173; /* pru_lmbd_implsihiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 174; /* pru_lmbd_implsihihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 175; /* pru_lmbd_implsihisi__z_z1_z2 */

                    case 2:
                      if (reg_or_ubyte_operand (operands[2], E_QImode))
                        return 176; /* pru_lmbd_implsisiqi__z_z1_z2 */
                      if (reg_or_ubyte_operand (operands[2], E_HImode))
                        return 178; /* pru_lmbd_implsisihi__z_z1_z2 */
                      if (!reg_or_ubyte_operand (operands[2], E_SImode))
                        return -1;
                      return 180; /* pru_lmbd_implsisisi__z_z1_z2 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern31 (x2, 
E_QImode) != 0)
                    return -1;
                  return 144; /* pru_lmbd_implqiqiqi__z_z1_noz2 */

                case E_HImode:
                  if (pattern31 (x2, 
E_HImode) != 0)
                    return -1;
                  return 163; /* pru_lmbd_implhihihi__z_z1_noz2 */

                case E_SImode:
                  if (pattern31 (x2, 
E_SImode) != 0)
                    return -1;
                  return 182; /* pru_lmbd_implsisisi__z_z1_noz2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern32 (x2, 
E_QImode) != 0)
                    return -1;
                  return 143; /* pru_lmbd_implqiqiqi__noz_z1_z2 */

                case E_HImode:
                  if (pattern32 (x2, 
E_HImode) != 0)
                    return -1;
                  return 162; /* pru_lmbd_implhihihi__noz_z1_z2 */

                case E_SImode:
                  if (pattern32 (x2, 
E_SImode) != 0)
                    return -1;
                  return 181; /* pru_lmbd_implsisisi__noz_z1_z2 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern33 (x2, 
E_QImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 145; /* pru_lmbd_implqiqiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 147; /* pru_lmbd_implqiqihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 149; /* pru_lmbd_implqiqisi__z_noz1_z2 */

                case E_HImode:
                  if (pattern33 (x2, 
E_HImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 160; /* pru_lmbd_implhihiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 164; /* pru_lmbd_implhihihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 166; /* pru_lmbd_implhihisi__z_noz1_z2 */

                case E_SImode:
                  if (pattern33 (x2, 
E_SImode) != 0)
                    return -1;
                  if (reg_or_ubyte_operand (operands[2], E_QImode))
                    return 177; /* pru_lmbd_implsisiqi__z_noz1_z2 */
                  if (reg_or_ubyte_operand (operands[2], E_HImode))
                    return 179; /* pru_lmbd_implsisihi__z_noz1_z2 */
                  if (!reg_or_ubyte_operand (operands[2], E_SImode))
                    return -1;
                  return 183; /* pru_lmbd_implsisisi__z_noz1_z2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x6 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 128)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (x3))
        {
        case E_HImode:
          if (GET_MODE (x2) != E_HImode
              || !reg_or_ubyte_operand (operands[0], E_HImode))
            return -1;
          return 712; /* pruloophi */

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !reg_or_ubyte_operand (operands[0], E_SImode))
            return -1;
          return 713; /* pruloopsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
