/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern0 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern0 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern15 (x1, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern15 (x1, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern15 (x1, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 14
          || GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case RETURN:
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[0] = x6;
      if (pru_cmp_operator (operands[0], E_VOIDmode))
        {
          switch (pattern27 (x2))
            {
            case 0:
              return 642; /* cbranchqi4_unsigned */

            case 1:
              return 643; /* cbranchhi4_unsigned */

            case 2:
              return 644; /* cbranchsi4_unsigned */

            default:
              break;
            }
        }
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTRACT)
        return -1;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      x11 = XEXP (x7, 2);
      operands[1] = x11;
      x12 = XEXP (x3, 0);
      operands[2] = x12;
      switch (GET_CODE (x6))
        {
        case EQ:
          switch (GET_MODE (x7))
            {
            case E_QImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 648; /* cbranch_qbbx_eqqiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 650; /* cbranch_qbbx_eqqihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 652; /* cbranch_qbbx_eqqisiqi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 654; /* cbranch_qbbx_eqhiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 656; /* cbranch_qbbx_eqhihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 658; /* cbranch_qbbx_eqhisiqi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 660; /* cbranch_qbbx_eqsiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 662; /* cbranch_qbbx_eqsihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 664; /* cbranch_qbbx_eqsisiqi4 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 666; /* cbranch_qbbx_eqqiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 668; /* cbranch_qbbx_eqqihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 670; /* cbranch_qbbx_eqqisihi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 672; /* cbranch_qbbx_eqhiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 674; /* cbranch_qbbx_eqhihihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 676; /* cbranch_qbbx_eqhisihi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 702; /* cbranch_qbbx_const_eqhi */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 678; /* cbranch_qbbx_eqsiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 680; /* cbranch_qbbx_eqsihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 682; /* cbranch_qbbx_eqsisihi4 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 684; /* cbranch_qbbx_eqqiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 686; /* cbranch_qbbx_eqqihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 688; /* cbranch_qbbx_eqqisisi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 690; /* cbranch_qbbx_eqhiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 692; /* cbranch_qbbx_eqhihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 694; /* cbranch_qbbx_eqhisisi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 696; /* cbranch_qbbx_eqsiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 698; /* cbranch_qbbx_eqsihisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 700; /* cbranch_qbbx_eqsisisi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 704; /* cbranch_qbbx_const_eqsi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 706; /* cbranch_qbbx_const_eqdi */

            default:
              return -1;
            }

        case NE:
          switch (GET_MODE (x7))
            {
            case E_QImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 649; /* cbranch_qbbx_neqiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 651; /* cbranch_qbbx_neqihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 653; /* cbranch_qbbx_neqisiqi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 655; /* cbranch_qbbx_nehiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 657; /* cbranch_qbbx_nehihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 659; /* cbranch_qbbx_nehisiqi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 661; /* cbranch_qbbx_nesiqiqi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 663; /* cbranch_qbbx_nesihiqi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 665; /* cbranch_qbbx_nesisiqi4 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 667; /* cbranch_qbbx_neqiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 669; /* cbranch_qbbx_neqihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 671; /* cbranch_qbbx_neqisihi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 673; /* cbranch_qbbx_nehiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 675; /* cbranch_qbbx_nehihihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 677; /* cbranch_qbbx_nehisihi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 703; /* cbranch_qbbx_const_nehi */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 679; /* cbranch_qbbx_nesiqihi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 681; /* cbranch_qbbx_nesihihi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 683; /* cbranch_qbbx_nesisihi4 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern34 ())
                {
                case 0:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 685; /* cbranch_qbbx_neqiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 687; /* cbranch_qbbx_neqihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 689; /* cbranch_qbbx_neqisisi4 */

                case 1:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 691; /* cbranch_qbbx_nehiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 693; /* cbranch_qbbx_nehihisi4 */
                  if (!reg_or_ubyte_operand (operands[1], E_SImode))
                    return -1;
                  return 695; /* cbranch_qbbx_nehisisi4 */

                case 2:
                  if (reg_or_ubyte_operand (operands[1], E_QImode))
                    return 697; /* cbranch_qbbx_nesiqisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_HImode))
                    return 699; /* cbranch_qbbx_nesihisi4 */
                  if (reg_or_ubyte_operand (operands[1], E_SImode))
                    return 701; /* cbranch_qbbx_nesisisi4 */
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 705; /* cbranch_qbbx_const_nesi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 707; /* cbranch_qbbx_const_nedi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      operands[0] = x6;
      if (!pru_signed_cmp_operator (operands[0], E_VOIDmode))
        return -1;
      switch (pattern27 (x2))
        {
        case 0:
          return 645; /* cbranchqi4_signed */

        case 1:
          return 646; /* cbranchhi4_signed */

        case 2:
          return 647; /* cbranchsi4_signed */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
