/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return pattern2 (); /* [-1, 2] */
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 6)
    return -1;
  return 0;
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern9 (x3, 
E_DImode) != 0)
                return -1;
              return 35; /* adddi3 */

            case E_QImode:
              if (pattern20 (x3, 
E_QImode) != 0)
                return -1;
              return 48; /* add_implqiqiqi__noz_z1_z2 */

            case E_HImode:
              if (pattern20 (x3, 
E_HImode) != 0)
                return -1;
              return 70; /* add_implhihihi__noz_z1_z2 */

            case E_SImode:
              if (pattern20 (x3, 
E_SImode) != 0)
                return -1;
              return 92; /* add_implsisisi__noz_z1_z2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1 (x3))
            {
            case 0:
              if (nonmemory_operand (operands[2], E_QImode))
                return 49; /* add_implqiqiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 51; /* add_implqiqihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 53; /* add_implqiqisi__z_noz1_z2 */

            case 1:
              if (nonmemory_operand (operands[2], E_QImode))
                return 67; /* add_implhihiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 71; /* add_implhihihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 73; /* add_implhihisi__z_noz1_z2 */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode))
                return 87; /* add_implsisiqi__z_noz1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 89; /* add_implsisihi__z_noz1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 93; /* add_implsisisi__z_noz1_z2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern5 (x3))
            {
            case 0:
              if (nonmemory_operand (operands[2], E_QImode))
                return 46; /* add_implqiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 50; /* add_implqiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 52; /* add_implqiqisi__z_z1_z2 */

            case 1:
              if (nonmemory_operand (operands[2], E_QImode))
                return 54; /* add_implqihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 56; /* add_implqihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 57; /* add_implqihisi__z_z1_z2 */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode))
                return 58; /* add_implqisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 60; /* add_implqisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 61; /* add_implqisisi__z_z1_z2 */

            case 3:
              if (nonmemory_operand (operands[2], E_QImode))
                return 62; /* add_implhiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 63; /* add_implhiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 65; /* add_implhiqisi__z_z1_z2 */

            case 4:
              if (nonmemory_operand (operands[2], E_QImode))
                return 66; /* add_implhihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 68; /* add_implhihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 72; /* add_implhihisi__z_z1_z2 */

            case 5:
              if (nonmemory_operand (operands[2], E_QImode))
                return 74; /* add_implhisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 75; /* add_implhisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 77; /* add_implhisisi__z_z1_z2 */

            case 6:
              if (nonmemory_operand (operands[2], E_QImode))
                return 78; /* add_implsiqiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 79; /* add_implsiqihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 80; /* add_implsiqisi__z_z1_z2 */

            case 7:
              if (nonmemory_operand (operands[2], E_QImode))
                return 82; /* add_implsihiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 83; /* add_implsihihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 84; /* add_implsihisi__z_z1_z2 */

            case 8:
              if (nonmemory_operand (operands[2], E_QImode))
                return 86; /* add_implsisiqi__z_z1_z2 */
              if (nonmemory_operand (operands[2], E_HImode))
                return 88; /* add_implsisihi__z_z1_z2 */
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 90; /* add_implsisisi__z_z1_z2 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern21 (x3, 
E_QImode))
                {
                case 0:
                  return 47; /* add_implqiqiqi__z_z1_noz2 */

                case 1:
                  return 55; /* add_implqihiqi__z_z1_noz2 */

                case 2:
                  return 59; /* add_implqisiqi__z_z1_noz2 */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern21 (x3, 
E_HImode))
                {
                case 0:
                  return 64; /* add_implhiqihi__z_z1_noz2 */

                case 1:
                  return 69; /* add_implhihihi__z_z1_noz2 */

                case 2:
                  return 76; /* add_implhisihi__z_z1_noz2 */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern21 (x3, 
E_SImode))
                {
                case 0:
                  return 81; /* add_implsiqisi__z_z1_noz2 */

                case 1:
                  return 85; /* add_implsihisi__z_z1_noz2 */

                case 2:
                  return 91; /* add_implsisisi__z_z1_noz2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
