/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 0;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 1;

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 2;

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              res = pattern3 (x3, 
E_QImode);
              if (res >= 0)
                return res + 7; /* [7, 9] */
              return -1;

            case E_HImode:
              res = pattern3 (x3, 
E_HImode);
              if (res >= 0)
                return res + 10; /* [10, 12] */
              return -1;

            case E_SImode:
              res = pattern3 (x3, 
E_SImode);
              if (res >= 0)
                return res + 13; /* [13, 15] */
              return -1;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern5 (x3);
          if (res >= 0)
            return res + 16; /* [16, 24] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (shift_operand (operands[2], E_QImode))
        return 517; /* ashl_implqiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 521; /* ashl_implqiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 523; /* ashl_implqiqisi__z_z1_z2 */

    case 1:
      if (shift_operand (operands[2], E_QImode))
        return 525; /* ashl_implqihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 527; /* ashl_implqihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 528; /* ashl_implqihisi__z_z1_z2 */

    case 2:
      if (shift_operand (operands[2], E_QImode))
        return 529; /* ashl_implqisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 531; /* ashl_implqisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 532; /* ashl_implqisisi__z_z1_z2 */

    case 3:
      if (shift_operand (operands[2], E_QImode))
        return 533; /* ashl_implhiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 534; /* ashl_implhiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 536; /* ashl_implhiqisi__z_z1_z2 */

    case 4:
      if (shift_operand (operands[2], E_QImode))
        return 537; /* ashl_implhihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 539; /* ashl_implhihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 543; /* ashl_implhihisi__z_z1_z2 */

    case 5:
      if (shift_operand (operands[2], E_QImode))
        return 545; /* ashl_implhisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 546; /* ashl_implhisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 548; /* ashl_implhisisi__z_z1_z2 */

    case 6:
      if (shift_operand (operands[2], E_QImode))
        return 549; /* ashl_implsiqiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 550; /* ashl_implsiqihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 551; /* ashl_implsiqisi__z_z1_z2 */

    case 7:
      if (shift_operand (operands[2], E_QImode))
        return 553; /* ashl_implsihiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 554; /* ashl_implsihihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 555; /* ashl_implsihisi__z_z1_z2 */

    case 8:
      if (shift_operand (operands[2], E_QImode))
        return 557; /* ashl_implsisiqi__z_z1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 559; /* ashl_implsisihi__z_z1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 561; /* ashl_implsisisi__z_z1_z2 */

    case 9:
      return 518; /* ashl_implqiqiqi__z_z1_noz2 */

    case 10:
      return 526; /* ashl_implqihiqi__z_z1_noz2 */

    case 11:
      return 530; /* ashl_implqisiqi__z_z1_noz2 */

    case 12:
      return 535; /* ashl_implhiqihi__z_z1_noz2 */

    case 13:
      return 540; /* ashl_implhihihi__z_z1_noz2 */

    case 14:
      return 547; /* ashl_implhisihi__z_z1_noz2 */

    case 15:
      return 552; /* ashl_implsiqisi__z_z1_noz2 */

    case 16:
      return 556; /* ashl_implsihisi__z_z1_noz2 */

    case 17:
      return 562; /* ashl_implsisisi__z_z1_noz2 */

    case 18:
      return 519; /* ashl_implqiqiqi__noz_z1_z2 */

    case 19:
      return 541; /* ashl_implhihihi__noz_z1_z2 */

    case 20:
      return 563; /* ashl_implsisisi__noz_z1_z2 */

    case 21:
      if (shift_operand (operands[2], E_QImode))
        return 520; /* ashl_implqiqiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 522; /* ashl_implqiqihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 524; /* ashl_implqiqisi__z_noz1_z2 */

    case 22:
      if (shift_operand (operands[2], E_QImode))
        return 538; /* ashl_implhihiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 542; /* ashl_implhihihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 544; /* ashl_implhihisi__z_noz1_z2 */

    case 23:
      if (shift_operand (operands[2], E_QImode))
        return 558; /* ashl_implsisiqi__z_noz1_z2 */
      if (shift_operand (operands[2], E_HImode))
        return 560; /* ashl_implsisihi__z_noz1_z2 */
      if (!shift_operand (operands[2], E_SImode))
        return -1;
      return 564; /* ashl_implsisisi__z_noz1_z2 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_11 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 0);
              operands[1] = x3;
              if (register_operand (operands[1], E_QImode)
                  && load_multiple_operation (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (memory_operand (operands[2], E_QImode)
                      && 
#line 340 "../../gcc/config/pru/pru.md"
(reload_completed))
                    return 21; /* *pru_load_multiple */
                }
              if (memory_operand (operands[1], E_QImode)
                  && store_multiple_operation (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (register_operand (operands[2], E_QImode)
                      && 
#line 398 "../../gcc/config/pru/pru.md"
(reload_completed))
                    return 22; /* *pru_store_multiple */
                }
            }
        }
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!call_operand (operands[0], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              x6 = XVECEXP (x1, 0, 1);
              switch (pattern28 (x6))
                {
                case 0:
                  return 637; /* *call */

                case 1:
                  if (!
#line 1261 "../../gcc/config/pru/pru.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 639; /* *sibcall */

                default:
                  return -1;
                }

            case SET:
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case CALL:
                  x7 = XEXP (x4, 0);
                  if (GET_CODE (x7) != MEM
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  x3 = XEXP (x2, 0);
                  operands[0] = x3;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!call_operand (operands[1], E_SImode))
                    return -1;
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  x6 = XVECEXP (x1, 0, 1);
                  switch (pattern28 (x6))
                    {
                    case 0:
                      return 638; /* *call_value */

                    case 1:
                      if (!register_operand (operands[0], E_VOIDmode)
                          || !
#line 1272 "../../gcc/config/pru/pru.md"
(SIBLING_CALL_P (insn)))
                        return -1;
                      return 640; /* *sibcall_value */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[0] = x4;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 0);
                  if (GET_CODE (x3) != PC)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != USE)
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (GET_CODE (x10) != LABEL_REF)
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[1] = x11;
                  return 641; /* *tablejump */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              x10 = XEXP (x6, 0);
              operands[1] = x10;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              switch (XINT (x2, 1))
                {
                case 2:
                  if (!const_uhword_operand (operands[0], E_SImode))
                    return -1;
                  return 717; /* delay_cycles_2x_plus1_hi */

                case 3:
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  return 718; /* delay_cycles_2x_plus2_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          if (pattern14 (x1) != 0)
            return -1;
          x13 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x13) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 1);
          x7 = XEXP (x4, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          x14 = XEXP (x9, 0);
          operands[1] = x14;
          x15 = XVECEXP (x1, 0, 2);
          x16 = XVECEXP (x15, 0, 0);
          operands[2] = x16;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x17 = XEXP (x13, 0);
          operands[3] = x17;
          x6 = XVECEXP (x1, 0, 1);
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          x10 = XEXP (x6, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x18) != E_HImode
                  || !scratch_operand (operands[3], E_HImode))
                return -1;
              return 710; /* doloop_end_internalhi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x18) != E_SImode
                  || !scratch_operand (operands[3], E_SImode))
                return -1;
              return 711; /* doloop_end_internalsi */

            default:
              return -1;
            }

        case 3:
          if (pnum_clobbers == NULL
              || pattern14 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 1);
          x7 = XEXP (x4, 0);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          x14 = XEXP (x9, 0);
          operands[1] = x14;
          x15 = XVECEXP (x1, 0, 2);
          x16 = XVECEXP (x15, 0, 0);
          operands[2] = x16;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          x10 = XEXP (x6, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x18) != E_HImode)
                return -1;
              *pnum_clobbers = 1;
              return 710; /* doloop_end_internalhi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x18) != E_SImode)
                return -1;
              *pnum_clobbers = 1;
              return 711; /* doloop_end_internalsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      if (
#line 1171 "../../gcc/config/pru/pru.md"
(pru_can_use_return_insn ()))
        return 632; /* return */
      return 633; /* simple_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 8:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 634; /* blockage */

        case 0:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_VOIDmode))
            return -1;
          return 715; /* delay_cycles_start */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_VOIDmode))
            return -1;
          return 716; /* delay_cycles_end */

        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_uhword_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 717; /* delay_cycles_2x_plus1_hi */

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 718; /* delay_cycles_2x_plus2_si */

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 719; /* delay_cycles_1 */

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 722; /* pru_halt */

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x20 = XEXP (x1, 0);
      if (GET_CODE (x20) != MEM
          || GET_MODE (x20) != E_SImode)
        return -1;
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!call_operand (operands[0], E_SImode))
        return -1;
      x22 = XEXP (x1, 1);
      operands[1] = x22;
      *pnum_clobbers = 1;
      return 637; /* *call */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 6)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 714; /* pruloop_end */

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 720; /* nop */

    default:
      return -1;
    }
}
