/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_ubyte_operand (operands[2], i1))
    return -1;
  return pattern2 (); /* [-1, 2] */
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          return pattern5 (x3); /* [-1, 8] */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              res = pattern11 (x3, 
E_QImode);
              if (res >= 0)
                return res + 9; /* [9, 11] */
              return -1;

            case E_HImode:
              res = pattern11 (x3, 
E_HImode);
              if (res >= 0)
                return res + 12; /* [12, 14] */
              return -1;

            case E_SImode:
              res = pattern11 (x3, 
E_SImode);
              if (res >= 0)
                return res + 15; /* [15, 17] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern12 (x3, 
E_QImode) != 0)
                return -1;
              return 18;

            case E_HImode:
              if (pattern12 (x3, 
E_HImode) != 0)
                return -1;
              return 19;

            case E_SImode:
              if (pattern12 (x3, 
E_SImode) != 0)
                return -1;
              return 20;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          res = pattern1 (x3);
          if (res >= 0)
            return res + 21; /* [21, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (nonimmediate_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode))
            return 1; /* prumovsi */
          break;

        case E_SQmode:
          if (nonimmediate_operand (operands[0], E_SQmode)
              && general_operand (operands[1], E_SQmode))
            return 2; /* prumovsq */
          break;

        case E_USQmode:
          if (nonimmediate_operand (operands[0], E_USQmode)
              && general_operand (operands[1], E_USQmode))
            return 3; /* prumovusq */
          break;

        case E_SAmode:
          if (nonimmediate_operand (operands[0], E_SAmode)
              && general_operand (operands[1], E_SAmode))
            return 4; /* prumovsa */
          break;

        case E_USAmode:
          if (nonimmediate_operand (operands[0], E_USAmode)
              && general_operand (operands[1], E_USAmode))
            return 5; /* prumovusa */
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[0], E_SFmode)
              && general_operand (operands[1], E_SFmode))
            return 6; /* prumovsf */
          break;

        case E_SDmode:
          if (nonimmediate_operand (operands[0], E_SDmode)
              && general_operand (operands[1], E_SDmode))
            return 7; /* prumovsd */
          break;

        case E_QImode:
          if (nonimmediate_operand (operands[0], E_QImode)
              && general_operand (operands[1], E_QImode))
            return 8; /* prumovqi */
          break;

        case E_QQmode:
          if (nonimmediate_operand (operands[0], E_QQmode)
              && general_operand (operands[1], E_QQmode))
            return 9; /* prumovqq */
          break;

        case E_UQQmode:
          if (nonimmediate_operand (operands[0], E_UQQmode)
              && general_operand (operands[1], E_UQQmode))
            return 10; /* prumovuqq */
          break;

        case E_HImode:
          if (nonimmediate_operand (operands[0], E_HImode)
              && general_operand (operands[1], E_HImode))
            return 11; /* prumovhi */
          break;

        case E_HQmode:
          if (nonimmediate_operand (operands[0], E_HQmode)
              && general_operand (operands[1], E_HQmode))
            return 12; /* prumovhq */
          break;

        case E_UHQmode:
          if (nonimmediate_operand (operands[0], E_UHQmode)
              && general_operand (operands[1], E_UHQmode))
            return 13; /* prumovuhq */
          break;

        case E_HAmode:
          if (nonimmediate_operand (operands[0], E_HAmode)
              && general_operand (operands[1], E_HAmode))
            return 14; /* prumovha */
          break;

        case E_UHAmode:
          if (nonimmediate_operand (operands[0], E_UHAmode)
              && general_operand (operands[1], E_UHAmode))
            return 15; /* prumovuha */
          break;

        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && general_operand (operands[1], E_DImode))
            return 16; /* movdi */
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[0], E_DFmode)
              && general_operand (operands[1], E_DFmode))
            return 17; /* movdf */
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[0], E_DDmode)
              && general_operand (operands[1], E_DDmode))
            return 18; /* movdd */
          break;

        case E_DQmode:
          if (nonimmediate_operand (operands[0], E_DQmode)
              && general_operand (operands[1], E_DQmode))
            return 19; /* movdq */
          break;

        case E_UDQmode:
          if (nonimmediate_operand (operands[0], E_UDQmode)
              && general_operand (operands[1], E_UDQmode))
            return 20; /* movudq */
          break;

        default:
          break;
        }
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (register_operand (operands[0], E_SImode))
        return 635; /* indirect_jump */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LABEL_REF
      || GET_CODE (x2) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  return 636; /* jump */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_9 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_2 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_6 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_7 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_4 (x1, insn, pnum_clobbers);

    case AND:
      return recog_5 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_1_operand (operands[2], E_QImode))
        return -1;
      switch (pattern17 (x2))
        {
        case 0:
          return 43; /* ashrqi3_single */

        case 1:
          return 44; /* ashrhi3_single */

        case 2:
          return 45; /* ashrsi3_single */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_3 (x1, insn, pnum_clobbers);

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern3 (x2, 
E_QImode))
                {
                case 0:
                  return 184; /* neg_implqiqi__z */

                case 1:
                  return 186; /* neg_implqihi__z */

                case 2:
                  return 187; /* neg_implqisi__z */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern3 (x2, 
E_HImode))
                {
                case 0:
                  return 188; /* neg_implhiqi__z */

                case 1:
                  return 189; /* neg_implhihi__z */

                case 2:
                  return 191; /* neg_implhisi__z */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern3 (x2, 
E_SImode))
                {
                case 0:
                  return 192; /* neg_implsiqi__z */

                case 1:
                  return 193; /* neg_implsihi__z */

                case 2:
                  return 194; /* neg_implsisi__z */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern17 (x2))
            {
            case 0:
              return 185; /* neg_implqiqi__noz */

            case 1:
              return 190; /* neg_implhihi__noz */

            case 2:
              return 195; /* neg_implsisi__noz */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern3 (x2, 
E_QImode))
                {
                case 0:
                  return 196; /* one_cmpl_implqiqi__z */

                case 1:
                  return 198; /* one_cmpl_implqihi__z */

                case 2:
                  return 199; /* one_cmpl_implqisi__z */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern3 (x2, 
E_HImode))
                {
                case 0:
                  return 200; /* one_cmpl_implhiqi__z */

                case 1:
                  return 201; /* one_cmpl_implhihi__z */

                case 2:
                  return 203; /* one_cmpl_implhisi__z */

                default:
                  return -1;
                }

            case E_SImode:
              switch (pattern3 (x2, 
E_SImode))
                {
                case 0:
                  return 204; /* one_cmpl_implsiqi__z */

                case 1:
                  return 205; /* one_cmpl_implsihi__z */

                case 2:
                  return 206; /* one_cmpl_implsisi__z */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 197; /* one_cmpl_implqiqi__noz */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 202; /* one_cmpl_implhihi__noz */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 207; /* one_cmpl_implsisi__noz */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 630; /* one_cmpldi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_8 (x1, insn, pnum_clobbers);

    case UMIN:
      switch (pattern10 (x1))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 247; /* umin_implqiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 263; /* umin_implqiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 273; /* umin_implqiqisi__z_z0_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 283; /* umin_implqihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 293; /* umin_implqihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 300; /* umin_implqihisi__z_z0_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 308; /* umin_implqisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 315; /* umin_implqisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 323; /* umin_implqisisi__z_z0_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 333; /* umin_implhiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 343; /* umin_implhiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 350; /* umin_implhiqisi__z_z0_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 358; /* umin_implhihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 377; /* umin_implhihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 393; /* umin_implhihisi__z_z0_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 400; /* umin_implhisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 408; /* umin_implhisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 418; /* umin_implhisisi__z_z0_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 428; /* umin_implsiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 435; /* umin_implsiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 443; /* umin_implsiqisi__z_z0_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 450; /* umin_implsihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 458; /* umin_implsihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 468; /* umin_implsihisi__z_z0_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 478; /* umin_implsisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 488; /* umin_implsisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 507; /* umin_implsisisi__z_z0_z1_z2 */

        case 9:
          return 248; /* umin_implqiqiqi__z_z0_z1_noz2 */

        case 10:
          return 284; /* umin_implqihiqi__z_z0_z1_noz2 */

        case 11:
          return 309; /* umin_implqisiqi__z_z0_z1_noz2 */

        case 12:
          return 344; /* umin_implhiqihi__z_z0_z1_noz2 */

        case 13:
          return 378; /* umin_implhihihi__z_z0_z1_noz2 */

        case 14:
          return 409; /* umin_implhisihi__z_z0_z1_noz2 */

        case 15:
          return 444; /* umin_implsiqisi__z_z0_z1_noz2 */

        case 16:
          return 469; /* umin_implsihisi__z_z0_z1_noz2 */

        case 17:
          return 508; /* umin_implsisisi__z_z0_z1_noz2 */

        case 18:
          return 249; /* umin_implqiqiqi__noz_z0_z1_z2 */

        case 19:
          return 379; /* umin_implhihihi__noz_z0_z1_z2 */

        case 20:
          return 509; /* umin_implsisisi__noz_z0_z1_z2 */

        case 21:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 251; /* umin_implqiqiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 264; /* umin_implqiqihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 274; /* umin_implqiqisi__z_z0_noz1_z2 */

        case 22:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 359; /* umin_implhihiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 381; /* umin_implhihihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 394; /* umin_implhihisi__z_z0_noz1_z2 */

        case 23:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 479; /* umin_implsisiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 489; /* umin_implsisihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 511; /* umin_implsisisi__z_z0_noz1_z2 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern10 (x1))
        {
        case 0:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 252; /* umax_implqiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 265; /* umax_implqiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 275; /* umax_implqiqisi__z_z0_z1_z2 */

        case 1:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 285; /* umax_implqihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 295; /* umax_implqihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 301; /* umax_implqihisi__z_z0_z1_z2 */

        case 2:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 310; /* umax_implqisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 316; /* umax_implqisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 325; /* umax_implqisisi__z_z0_z1_z2 */

        case 3:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 335; /* umax_implhiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 345; /* umax_implhiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 351; /* umax_implhiqisi__z_z0_z1_z2 */

        case 4:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 360; /* umax_implhihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 382; /* umax_implhihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 395; /* umax_implhihisi__z_z0_z1_z2 */

        case 5:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 401; /* umax_implhisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 410; /* umax_implhisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 420; /* umax_implhisisi__z_z0_z1_z2 */

        case 6:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 430; /* umax_implsiqiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 436; /* umax_implsiqihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 445; /* umax_implsiqisi__z_z0_z1_z2 */

        case 7:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 451; /* umax_implsihiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 460; /* umax_implsihihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 470; /* umax_implsihisi__z_z0_z1_z2 */

        case 8:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 480; /* umax_implsisiqi__z_z0_z1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 490; /* umax_implsisihi__z_z0_z1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 512; /* umax_implsisisi__z_z0_z1_z2 */

        case 9:
          return 253; /* umax_implqiqiqi__z_z0_z1_noz2 */

        case 10:
          return 286; /* umax_implqihiqi__z_z0_z1_noz2 */

        case 11:
          return 311; /* umax_implqisiqi__z_z0_z1_noz2 */

        case 12:
          return 346; /* umax_implhiqihi__z_z0_z1_noz2 */

        case 13:
          return 383; /* umax_implhihihi__z_z0_z1_noz2 */

        case 14:
          return 411; /* umax_implhisihi__z_z0_z1_noz2 */

        case 15:
          return 446; /* umax_implsiqisi__z_z0_z1_noz2 */

        case 16:
          return 471; /* umax_implsihisi__z_z0_z1_noz2 */

        case 17:
          return 513; /* umax_implsisisi__z_z0_z1_noz2 */

        case 18:
          return 254; /* umax_implqiqiqi__noz_z0_z1_z2 */

        case 19:
          return 384; /* umax_implhihihi__noz_z0_z1_z2 */

        case 20:
          return 514; /* umax_implsisisi__noz_z0_z1_z2 */

        case 21:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 256; /* umax_implqiqiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 266; /* umax_implqiqihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 276; /* umax_implqiqisi__z_z0_noz1_z2 */

        case 22:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 361; /* umax_implhihiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 386; /* umax_implhihihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 396; /* umax_implhihisi__z_z0_noz1_z2 */

        case 23:
          if (reg_or_ubyte_operand (operands[2], E_QImode))
            return 481; /* umax_implsisiqi__z_z0_noz1_z2 */
          if (reg_or_ubyte_operand (operands[2], E_HImode))
            return 491; /* umax_implsisihi__z_z0_noz1_z2 */
          if (!reg_or_ubyte_operand (operands[2], E_SImode))
            return -1;
          return 516; /* umax_implsisisi__z_z0_noz1_z2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_10 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      switch (pattern13 (x1))
        {
        case 0:
          if (shift_operand (operands[2], E_QImode))
            return 565; /* lshr_implqiqiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 570; /* lshr_implqiqihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 572; /* lshr_implqiqisi__z_z0_z1_z2 */

        case 1:
          if (shift_operand (operands[2], E_QImode))
            return 574; /* lshr_implqihiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 576; /* lshr_implqihihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 578; /* lshr_implqihisi__z_z0_z1_z2 */

        case 2:
          if (shift_operand (operands[2], E_QImode))
            return 579; /* lshr_implqisiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 581; /* lshr_implqisihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 582; /* lshr_implqisisi__z_z0_z1_z2 */

        case 3:
          if (shift_operand (operands[2], E_QImode))
            return 584; /* lshr_implhiqiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 586; /* lshr_implhiqihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 588; /* lshr_implhiqisi__z_z0_z1_z2 */

        case 4:
          if (shift_operand (operands[2], E_QImode))
            return 589; /* lshr_implhihiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 591; /* lshr_implhihihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 596; /* lshr_implhihisi__z_z0_z1_z2 */

        case 5:
          if (shift_operand (operands[2], E_QImode))
            return 598; /* lshr_implhisiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 599; /* lshr_implhisihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 601; /* lshr_implhisisi__z_z0_z1_z2 */

        case 6:
          if (shift_operand (operands[2], E_QImode))
            return 603; /* lshr_implsiqiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 605; /* lshr_implsiqihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 606; /* lshr_implsiqisi__z_z0_z1_z2 */

        case 7:
          if (shift_operand (operands[2], E_QImode))
            return 608; /* lshr_implsihiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 609; /* lshr_implsihihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 611; /* lshr_implsihisi__z_z0_z1_z2 */

        case 8:
          if (shift_operand (operands[2], E_QImode))
            return 613; /* lshr_implsisiqi__z_z0_z1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 615; /* lshr_implsisihi__z_z0_z1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 617; /* lshr_implsisisi__z_z0_z1_z2 */

        case 9:
          return 566; /* lshr_implqiqiqi__z_z0_z1_noz2 */

        case 10:
          return 575; /* lshr_implqihiqi__z_z0_z1_noz2 */

        case 11:
          return 580; /* lshr_implqisiqi__z_z0_z1_noz2 */

        case 12:
          return 587; /* lshr_implhiqihi__z_z0_z1_noz2 */

        case 13:
          return 592; /* lshr_implhihihi__z_z0_z1_noz2 */

        case 14:
          return 600; /* lshr_implhisihi__z_z0_z1_noz2 */

        case 15:
          return 607; /* lshr_implsiqisi__z_z0_z1_noz2 */

        case 16:
          return 612; /* lshr_implsihisi__z_z0_z1_noz2 */

        case 17:
          return 618; /* lshr_implsisisi__z_z0_z1_noz2 */

        case 18:
          return 567; /* lshr_implqiqiqi__noz_z0_z1_z2 */

        case 19:
          return 593; /* lshr_implhihihi__noz_z0_z1_z2 */

        case 20:
          return 619; /* lshr_implsisisi__noz_z0_z1_z2 */

        case 21:
          if (shift_operand (operands[2], E_QImode))
            return 569; /* lshr_implqiqiqi__z_z0_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 571; /* lshr_implqiqihi__z_z0_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 573; /* lshr_implqiqisi__z_z0_noz1_z2 */

        case 22:
          if (shift_operand (operands[2], E_QImode))
            return 590; /* lshr_implhihiqi__z_z0_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 595; /* lshr_implhihihi__z_z0_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 597; /* lshr_implhihisi__z_z0_noz1_z2 */

        case 23:
          if (shift_operand (operands[2], E_QImode))
            return 614; /* lshr_implsisiqi__z_z0_noz1_z2 */
          if (shift_operand (operands[2], E_HImode))
            return 616; /* lshr_implsisihi__z_z0_noz1_z2 */
          if (!shift_operand (operands[2], E_SImode))
            return -1;
          return 621; /* lshr_implsisisi__z_z0_noz1_z2 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          switch (XINT (x2, 1))
            {
            case 9:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x7 = XVECEXP (x2, 0, 0);
              operands[1] = x7;
              if (!regio_operand (operands[1], E_SImode))
                return -1;
              return 622; /* *regio_readsi */

            case 10:
              if (!regio_operand (operands[0], E_SImode))
                return -1;
              x7 = XVECEXP (x2, 0, 0);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  return 623; /* *regio_nozext_writesi */

                case ZERO_EXTEND:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  switch (pattern29 ())
                    {
                    case 0:
                      return 624; /* *regio_zext_write_r30qi */

                    case 1:
                      return 625; /* *regio_zext_write_r30hi */

                    case 2:
                      return 626; /* *regio_zext_write_r30si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 5)
            return -1;
          x7 = XVECEXP (x2, 0, 0);
          operands[1] = x7;
          x9 = XVECEXP (x2, 0, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !reg_or_ubyte_operand (operands[1], E_HImode))
                return -1;
              return 708; /* doloop_begin_internalhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_ubyte_operand (operands[1], E_SImode))
                return -1;
              return 709; /* doloop_begin_internalsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!pru_muldst_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!pru_mulsrc0_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!pru_mulsrc1_operand (operands[2], E_SImode))
        return -1;
      return 631; /* mulsi3 */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      *pnum_clobbers = 1;
      return 638; /* *call_value */

    case IF_THEN_ELSE:
      return recog_1 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
